"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Nft = void 0;
const shared_1 = require("../../../shared");
const utils_1 = require("../../../utils");
class Nft extends shared_1.Model {
    constructor(metadataAccount, masterEditionAccount = null, metadata = null) {
        var _a, _b;
        super();
        this.metadataAccount = metadataAccount;
        this.masterEditionAccount = masterEditionAccount;
        this.metadata = metadata;
        this.updateAuthority = metadataAccount.data.updateAuthority;
        this.mint = metadataAccount.data.mint;
        this.name = (0, utils_1.removeEmptyChars)(metadataAccount.data.data.name);
        this.symbol = (0, utils_1.removeEmptyChars)(metadataAccount.data.data.symbol);
        this.uri = (0, utils_1.removeEmptyChars)(metadataAccount.data.data.uri);
        this.sellerFeeBasisPoints = metadataAccount.data.data.sellerFeeBasisPoints;
        this.creators = metadataAccount.data.data.creators;
        this.primarySaleHappened = metadataAccount.data.primarySaleHappened;
        this.isMutable = metadataAccount.data.isMutable;
        this.editionNonce = metadataAccount.data.editionNonce;
        this.tokenStandard = metadataAccount.data.tokenStandard;
        this.collection = metadataAccount.data.collection;
        this.uses = metadataAccount.data.uses;
        this.supply = (_a = masterEditionAccount === null || masterEditionAccount === void 0 ? void 0 : masterEditionAccount.data.supply) !== null && _a !== void 0 ? _a : null;
        this.maxSupply = (_b = masterEditionAccount === null || masterEditionAccount === void 0 ? void 0 : masterEditionAccount.data.maxSupply) !== null && _b !== void 0 ? _b : null;
    }
}
exports.Nft = Nft;
//# sourceMappingURL=Nft.js.map