"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setAuthorityBuilder = void 0;
const web3_js_1 = require("@safecoin/web3.js");
const safe_token_1 = require("@safecoin/safe-token");
const shared_1 = require("../../../shared");
const setAuthorityBuilder = (params) => {
    const { mint, currentAuthority, authorityType, newAuthority, multiSigners = [], tokenProgram = safe_token_1.TOKEN_PROGRAM_ID, instructionKey = 'setAuthority', } = params;
    const [currentAuthorityPublicKey, signers] = currentAuthority instanceof web3_js_1.PublicKey
        ? [currentAuthority, multiSigners]
        : [currentAuthority.publicKey, [currentAuthority]];
    return shared_1.TransactionBuilder.make().add({
        instruction: (0, safe_token_1.createSetAuthorityInstruction)(mint, currentAuthorityPublicKey, authorityType, newAuthority, multiSigners, tokenProgram),
        signers,
        key: instructionKey,
    });
};
exports.setAuthorityBuilder = setAuthorityBuilder;
//# sourceMappingURL=setAuthorityBuilder.js.map