import { PublicKey } from '@safecoin/web3.js';
import { Model } from "../../../shared";
import { MetadataAccount, MasterEditionAccount } from "../../../programs/tokenMetadata";
import { TokenStandard, Collection, Uses, Creator } from '@leda-mint-io/lpl-token-metadata';
import { bignum } from '@j0nnyboi/beet';
import { JsonMetadata } from './JsonMetadata';
export declare class Nft extends Model {
    /** The Metadata PDA account defining the NFT. */
    readonly metadataAccount: MetadataAccount;
    /** The optional Metadata Edition PDA account associated with the NFT. */
    readonly masterEditionAccount: MasterEditionAccount | null;
    /** The JSON metadata from the URI. */
    readonly metadata: JsonMetadata | null;
    /** Data from the Metadata account. */
    readonly updateAuthority: PublicKey;
    readonly mint: PublicKey;
    readonly name: string;
    readonly symbol: string;
    readonly uri: string;
    readonly sellerFeeBasisPoints: number;
    readonly creators: Creator[] | null;
    readonly primarySaleHappened: boolean;
    readonly isMutable: boolean;
    readonly editionNonce: number | null;
    readonly tokenStandard: TokenStandard | null;
    readonly collection: Collection | null;
    readonly uses: Uses | null;
    /** Data from the MasterEdition account. */
    readonly supply: bignum | null;
    readonly maxSupply: bignum | null;
    constructor(metadataAccount: MetadataAccount, masterEditionAccount?: MasterEditionAccount | null, metadata?: JsonMetadata | null);
}
